set echo on

drop table t1;

purge table t1;

create table t1 (
d1 date,
n1 number(8),
v1 varchar2(8),
v2 varchar2(10)
)
;

-- Five years worth of data
-- Each row represents one day
-- Store as DATE, NUMBER and VARCHAR
insert into t1
select
d1,
to_number(to_char(d1,'yyyymmdd')),
to_char(d1,'yyyymmdd'),
to_char(d1,'yyyy-mm-dd')
from
(
select
to_date('31-Dec-1999', 'dd-mon-yyyy', 'nls_language = american') + rownum d1
from
dual
connect by
level <= 1827
)
;

commit;

exec dbms_stats.gather_table_stats(null, 't1', method_opt => 'for all columns size 1')

-- Ask for seven days
explain plan for
select *
from t1
where d1 between to_date('30-Dec-2002','dd-mon-yyyy')
and to_date('05-Jan-2003','dd-mon-yyyy')
;

select * from table(dbms_xplan.display(null, null, 'BASIC +ROWS'));

-- Ask for seven days (ouch!)
explain plan for
select *
from t1
where n1 between 20021230 and 20030105;

select * from table(dbms_xplan.display(null, null, 'BASIC +ROWS'));

-- Ask for seven days (ouch!)
explain plan for
select *
from t1
where v1 between '20021230' and '20030105';

select * from table(dbms_xplan.display(null, null, 'BASIC +ROWS'));

-- Ask for seven days (ouch!)
explain plan for
select *
from t1
where v2 between '2002-12-30' and '2003-01-05';

select * from table(dbms_xplan.display(null, null, 'BASIC +ROWS'));
