set echo on

drop table t;

purge table t;

-- 10,000 distinct values in VC and NVC
-- 10 values each, uniformly distributed
create table t
as
select
        rownum as id
      , cast('DESC' || to_char(mod(rownum, 10000) + 1, 'TM') as varchar2(20))  as vc
      , cast('DESC' || to_char(mod(rownum, 10000) + 1, 'TM') as nvarchar2(20)) as nvc
from
        dual
connect by
        level<= 100000
;

exec dbms_stats.gather_table_stats(null, 't')

/*
select
        vc
      , count(*) as cnt
from
        t
group by
        vc
order by
        vc
;
*/

-- Correct estimate
explain plan for
select count(*) from t where vc = 'DESC1';

select * from table(dbms_xplan.display);

-- Implicit data type conversion, incorrect cardinality estimate
explain plan for
select count(*) from t where vc = U'DESC1';

select * from table(dbms_xplan.display);


