set timing on echo on verify on

define lock_name = 'CONCURRENT_EXECUTION'

-- variable n_run_id number

-- exec select seq_t1_run_id.nextval into :n_run_id from dual;

-- The following is a hack to use default
-- values for defines
column 1 new_value 1
column 2 new_value 2

select
        '' as "1"
      , '' as "2"
from
        dual
where
        rownum = 0;

column run_id new_value run_id noprint
column iter new_value iter noprint

-- By default run 100 iterations
select
        nvl('&1', '100')               as run_id
      , nvl('&2', '100')               as iter
from
        dual;

variable lock_handle varchar2(60)

declare
  n         number;
begin
  dbms_lock.allocate_unique(
    lockname    => '&lock_name',
    lockhandle  => :lock_handle
  );
  n := dbms_lock.request(
    lockhandle        => :lock_handle,
    lockmode          => sys.dbms_lock.s_mode,
    timeout           => dbms_lock.maxwait,
    release_on_commit => false
  );
end;
/

declare
begin
  for i in 1..&iter loop
    for j in 1..100 loop
      insert into t1 (
                     run_id
                   , batch_id
                   , a_value,
                     a_random
                     )
      values         (
                     &run_id
                   , i
                   , seq_t1_seq_id.nextval /*j*/ /* use seq_t1_seq_id.nextval alternatively */
                   , trunc(dbms_random.value(1, 1000))
                     );
    end loop;
    commit;
    dbms_lock.sleep(0.01);
  end loop;
  commit;
end;
/

declare
  n         number;
begin
  n := dbms_lock.release(
    lockhandle        => :lock_handle
  );
end;
/
